<?php

/*************************************************************
*  TorrentFlux - PHP Torrent Manager
*  www.torrentflux.com
**************************************************************/
/*
    This file is part of TorrentFlux.

    TorrentFlux is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    TorrentFlux is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TorrentFlux; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

include_once("config.php");
include_once("functions.php");


// Are we to delete something?
if ($del != "")
{
	// The following lines of code were suggested by Jody Steele jmlsteele@stfu.ca
	// this is so only the owner of the file(s) or admin can delete
	if(IsAdmin($cfg["user"]) || preg_match("/^" . $cfg["user"] . "/",$del))
	{
		// Yes, then delete it

		// we need to strip slashes twice in some circumstances
		// Ex.  If we are trying to delete test/tester's file/test.txt
		//	$del will be "test/tester\\\'s file/test.txt"
		//	one strip will give us "test/tester\'s file/test.txt
		//	the second strip will give us the correct
		//		"test/tester's file/test.txt"

		$del = stripslashes(stripslashes($del));

		if (!ereg("(\.\.)", $del))
		{
			avddelete($cfg["path"].$del);
		}

		AuditAction($cfg["constants"]["fm_delete"], $del);
	}
	else
	{
		AuditAction($cfg["constants"]["error"], "ILLEGAL DELETE: ".$cfg['user']." tried to delete ".$del);
	}

	header("Location: dir.php");
}

if (isset($dir))
{
	if (ereg("(\.\.)", $dir))
	{
		unset($dir);
	}
	else
	{
		$dir = $dir."/";
	}
}

DisplayHead(_DIRECTORYLIST);
?>

<script language="JavaScript">
function ConfirmDelete(file)
{
	return confirm("<?PHP echo _ABOUTTODELETE ?>: " + file)
}
</script>

<?PHP

displayDriveSpaceBar(getDriveSpace($cfg["path"]));
echo "<br>";

ListDirectory($cfg["path"].$dir);

DisplayFoot();


//**************************************************************************
// ListDirectory()
// This method reads files and directories in the specified path and
// displayes them.
function ListDirectory($dirName)
{
	global $dir, $cfg;
	$bgLight = $cfg["bgLight"];
	$bgDark = $cfg["bgDark"];

	$bg = $bgLight;

	$dirName = stripslashes($dirName);

	if (isset($dir))
	{
		//setup default parent directory URL
		$parentURL = "dir.php";

		//get the real parentURL
		if (preg_match("/^(.+)\/.+$/",$dir,$matches) == 1)
		{
			$parentURL="dir.php?dir=" . urlencode($matches[1]);
		}

		echo "<a href=\"" . $parentURL . "\"><img src=\"images/up_dir.gif\" width=16 height=16 alt=\""._BACKTOPARRENT."\" border=0>["._BACKTOPARRENT."]</a>";
	}

	echo "<table cellpadding=2 width=740>";
	$handle = opendir($dirName);
	while($entry = readdir($handle))
	{
		if ($entry != "." && $entry != ".." && substr($entry, 0, 1) != ".")
		{
			if (@is_dir($dirName.$entry))
			{
				echo "<tr bgcolor=\"".$bg."\"><td><a href=\"dir.php?dir=".urlencode($dir.$entry)."\"><img src=\"images/folder.gif\" width=\"16\" height=\"16\" alt=\"".$entry."\" border=\"0\" align=\"absmiddle\">".$entry."</a></td>";
				echo "<td>&nbsp;</td>";
				echo "<td>&nbsp;</td>";
				echo "<td align=\"right\">";

				// The following lines of code were suggested by Jody Steele jmlsteele@stfu.ca
				// this is so only the owner of the file(s) or admin can delete
				// only give admins and users who "own" this directory
				// the ability to delete sub directories

				if(IsAdmin($cfg["user"]) || preg_match("/^" . $cfg["user"] . "/",$dir))
				{
					echo "<a href=\"dir.php?del=".urlencode($dir.$entry)."\" onclick=\"return ConfirmDelete('".addslashes($entry)."')\"><img src=\"images/delete_on.gif\" width=16 height=16 alt=\""._DELETE."\" border=0></a>";
				}
				else
				{
					echo "&nbsp;";
				}
				echo "</td></tr>\n";
				if ($bg == $bgLight)
				{
					$bg = $bgDark;
				}
				else
				{
					$bg = $bgLight;
				}
			}
			else
			{
				// Do nothing
			}
		}
	}
	closedir($handle);

	$handle = opendir($dirName);
	while($entry = readdir($handle))
	{
		if ($entry != "." && $entry != "..")
		{
			if (@is_dir($dirName.$entry))
			{
				// Do nothing
			}
			else
			{
				$arStat = @lstat($dirName.$entry);
				$timeStamp = $arStat[10];
				$fileSize = number_format(($arStat[7])/1024);
				echo "<tr bgcolor=\"".$bg."\"><td><img src=\"images/time.gif\" width=\"16\" height=\"16\" alt=\"".$entry."\" border=\"0\">".$entry."</td>";
				echo "<td align=\"right\">".$fileSize." KB</td>";
				echo "<td>".date("m-d-Y g:i a", $timeStamp)."</td>";
               	                echo "<td align=\"right\">";

				// The following lines of code were suggested by Jody Steele jmlsteele@stfu.ca
				// this is so only the owner of the file(s) or admin can delete
				// only give admins and users who "own" this directory
				// the ability to delete files

				if(IsAdmin($cfg["user"]) || preg_match("/^" . $cfg["user"] . "/",$dir))
				{
					echo "<a href=\"dir.php?del=".urlencode($dir.$entry)."\" onclick=\"return ConfirmDelete('".addslashes($entry)."')\"><img src=\"images/delete_on.gif\" width=16 height=16 alt=\""._DELETE."\" border=0></a>";
				}
				else
				{
					echo "&nbsp;";
				}
				echo "</td></tr>\n";

				if ($bg == $bgLight)
				{
					$bg = $bgDark;
				}
				else
				{
					$bg = $bgLight;
				}
			}
		}
	}
	closedir($handle);
	echo "</table>";
}

?>
